package com.caimei.service.auth.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.caimei.mapper.cmMapper.AddressMapper;
import com.caimei.mapper.cmMapper.AuthMapper;
import com.caimei.mapper.cmMapper.BannerMapper;
import com.caimei.model.ResponseJson;
import com.caimei.model.po.CmBrandAuthPo;
import com.caimei.model.po.CmBrandBannerPo;
import com.caimei.model.po.TownPo;
import com.caimei.model.vo.AddressSelectVo;
import com.caimei.model.vo.RossAddressVo;
import com.caimei.service.auth.AddressService;
import com.caimei.service.auth.BannerService;
import com.caimei.service.auth.UploadService;
import com.caimei.utils.OSSUtils;
import com.caimei.utils.RequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * cm_brand_auth
 *
 * @author : Kaick
 * @date : 2023/3/23
 */
@Slf4j
@Service
public class BannerServiceImpl implements BannerService {
    @Resource
    private BannerMapper bannerMapper;

    @Override
    @Transactional
    public ResponseJson saveBanner(CmBrandBannerPo bannerPo) {
        CmBrandBannerPo cmBrandBannerPo = bannerMapper.geteBanner(bannerPo.getAuthUserId());
        if (null == cmBrandBannerPo){
            // 插入首页Banner信息
            bannerMapper.addBanner(bannerPo);
        }else{
            // 更新首页Banner信息
            bannerMapper.setBanner(bannerPo);
        }
        return ResponseJson.success("首页Banner上传成功");
    }

    @Override
    public ResponseJson getBanner(Integer authUserId) {
        if (null == authUserId) {
            return ResponseJson.error("参数异常,供应商id不能为空", null);
        }
        return ResponseJson.success(bannerMapper.geteBanner(authUserId));
    }

    @Override
    public ResponseJson setBanner(CmBrandBannerPo bannerPo) {
        bannerMapper.setBanner(bannerPo);
        return ResponseJson.success(ResponseJson.success("修改首页Banner成功"));
    }

    @Override
    public ResponseJson deleteBanner(Integer authUserId) {
        if (null == authUserId) {
            return ResponseJson.error("参数异常，请输入供应商id",null);
        }
        bannerMapper.deleteBanner(authUserId);
        return ResponseJson.success("删除首页Banner成功");
    }
}
